/*
 * file: clpm.pro
 *
 * 'meal' calculation
 *	  (restricted sum of price, energy content, or whatever)
 */

% Tests the interface only
%	- all passed formuli are pure ground terms.
%  - If the constraint-setting is moved to the front, then 'real' work.

:-module(coint,[main_goal/0]).

main_goal :-
      select_clp_solver,
	lightmeal(_A,_M,_D).
        
lightmeal(A,M,D):-
%   clp_constraint([ I>=0, J>=0 ,K>=0, I+J+K =< 10 ]),	% (here pre-filters the choices)
    appetizer(A,I),
    main_course(M,J),
    desert(D,K),
    clp_constraint([ I>=0, J>=0, K>=0, I+J+K =< 10 ]),	% (in this position only the interface is working!)
    format(' A = ~a M = ~a D = ~a~n', [A, M, D]),
    fail.
lightmeal(_A,_M,_D):-
  format('END~n', []).
    

main_course(M,J) :- meat(M,J).
main_course(M,J) :- fish(M,J).

appetizer(radishes,1).
appetizer(caviar,3).
appetizer(salad,6).

meat(beef,5).
meat(pork,7).
meat(lamb,8).

fish(sole,2).
fish(tuna,4).

desert(fruit,2).
desert(icecream,6).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
