/*
 * file: pay.pro
 *
 * Calculates installment values for a 3-year loan
 *	to be payed each year, with the condition
 *	that the ration of the yearly payments be
 *		1 : 2 : 3
 */

:-module(payment,[main_goal/0]).

main_goal:-
%	clp_debug_mode(255),		% Set all flags!!!???
	clp_debug_mode(128),		% Trace messages only
	  payment([I1, I2, I3], 1000),
          clp_constraint([I2 =:= 2 * I1, I3 =:= 3 * I1]),
%         clp_value([I1, I2, I3], [V1, V2, V3]),
%         format('Installment values: I1=~f, I2=~f, I3=~f~n',[V1,V2,V3]).
          clp_value([I1, I2, I3], VL),
          format('Installment values: I1=~f, I2=~f, I3=~f~n', VL).

:-meta_predicate(payment(+,?)).
payment([], 0).
payment([INST|IL], MONEY):-
%       clp_constraint([1.1 * MONEY - INST =:= REM]),
        clp_constraint([(1 + 10 / 100) * MONEY - INST =:= REM]),
        payment(IL, REM).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
